Index: XIOS/trunk/extern/remap/src/cputime.cpp
===================================================================
--- XIOS/trunk/extern/remap/src/cputime.cpp	(revision 688)
+++ XIOS/trunk/extern/remap/src/cputime.cpp	(revision 694)
@@ -1,3 +1,3 @@
-#include <mpi.h>
+#include "mpi.hpp"
 
 namespace sphereRemap {
Index: XIOS/trunk/extern/remap/src/libmapper.cpp
===================================================================
--- XIOS/trunk/extern/remap/src/libmapper.cpp	(revision 688)
+++ XIOS/trunk/extern/remap/src/libmapper.cpp	(revision 694)
@@ -1,4 +1,3 @@
-//#include "mpi.h" // some compiler fails if mpi.h is not the first header to be included
-#include <mpi.h>
+#include "mpi.hpp"
 #include <vector>
 #include <cassert>
Index: XIOS/trunk/extern/remap/src/mapper.cpp
===================================================================
--- XIOS/trunk/extern/remap/src/mapper.cpp	(revision 688)
+++ XIOS/trunk/extern/remap/src/mapper.cpp	(revision 694)
@@ -1,4 +1,3 @@
-//#include "mpi.h" // some compiler fails if mpi.h is not the first header to be included
-#include <mpi.h>
+#include "mpi.hpp"
 #include <map>
 #include "cputime.hpp"       /* time */
Index: XIOS/trunk/extern/remap/src/mapper.hpp
===================================================================
--- XIOS/trunk/extern/remap/src/mapper.hpp	(revision 688)
+++ XIOS/trunk/extern/remap/src/mapper.hpp	(revision 694)
@@ -2,6 +2,5 @@
 #define __MAPPER_HPP__
 #include "parallel_tree.hpp"
-#include <mpi.h>
-//#include "mpi.h"
+#include "mpi.hpp"
 
 namespace sphereRemap {
Index: XIOS/trunk/extern/remap/src/mpi_cascade.hpp
===================================================================
--- XIOS/trunk/extern/remap/src/mpi_cascade.hpp	(revision 688)
+++ XIOS/trunk/extern/remap/src/mpi_cascade.hpp	(revision 694)
@@ -2,5 +2,5 @@
 #define  __MPI_CASCADE_HPP__
 
-#include <mpi.h>
+#include "mpi.hpp"
 #include <vector>
 #include <cassert>
Index: XIOS/trunk/extern/remap/src/mpi_routing.cpp
===================================================================
--- XIOS/trunk/extern/remap/src/mpi_routing.cpp	(revision 688)
+++ XIOS/trunk/extern/remap/src/mpi_routing.cpp	(revision 694)
@@ -1,4 +1,4 @@
 #include "mpi_routing.hpp"
-#include <mpi.h>
+#include "mpi.hpp"
 #include "node.hpp"
 #include "elt.hpp"
Index: XIOS/trunk/extern/remap/src/mpi_routing.hpp
===================================================================
--- XIOS/trunk/extern/remap/src/mpi_routing.hpp	(revision 688)
+++ XIOS/trunk/extern/remap/src/mpi_routing.hpp	(revision 694)
@@ -2,5 +2,5 @@
 #define  __MPI_ROUTING_HPP__
 
-#include <mpi.h>
+#include "mpi.hpp"
 #include <vector>
 #include "mpi_cascade.hpp"
Index: XIOS/trunk/extern/remap/src/node.cpp
===================================================================
--- XIOS/trunk/extern/remap/src/node.cpp	(revision 688)
+++ XIOS/trunk/extern/remap/src/node.cpp	(revision 694)
@@ -1,4 +1,3 @@
-//#include "mpi.h" // some compiler fails if mpi.h is not the first header to be included
-#include <mpi.h>
+#include "mpi.hpp"
 #include <cstdlib>
 #include <cmath>
Index: XIOS/trunk/extern/remap/src/parallel_tree.hpp
===================================================================
--- XIOS/trunk/extern/remap/src/parallel_tree.hpp	(revision 688)
+++ XIOS/trunk/extern/remap/src/parallel_tree.hpp	(revision 694)
@@ -5,6 +5,5 @@
 //#include "sample_tree.hpp"
 #include "mpi_cascade.hpp"
-//#include "mpi.h"
-#include <mpi.h>
+#include "mpi.hpp"
 
 namespace sphereRemap {
Index: XIOS/trunk/extern/remap/src/timerRemap.cpp
===================================================================
--- XIOS/trunk/extern/remap/src/timerRemap.cpp	(revision 688)
+++ XIOS/trunk/extern/remap/src/timerRemap.cpp	(revision 694)
@@ -1,4 +1,4 @@
 #include "timerRemap.hpp"
-#include <mpi.h>
+#include "mpi.hpp"
 #include <string>
 #include <map>
Index: XIOS/trunk/extern/remap/src/timerRemap.hpp
===================================================================
--- XIOS/trunk/extern/remap/src/timerRemap.hpp	(revision 688)
+++ XIOS/trunk/extern/remap/src/timerRemap.hpp	(revision 694)
@@ -2,6 +2,5 @@
 #define __TIMER_HPP__
 
-#include <mpi.h> // some compiler fails if mpi.h is not the first header to be included
-//#include "mpi.h" // some compiler fails if mpi.h is not the first header to be included
+#include "mpi.hpp"
 #include <string>
 #include <map>
Index: XIOS/trunk/extern/remap/src/tree.cpp
===================================================================
--- XIOS/trunk/extern/remap/src/tree.cpp	(revision 688)
+++ XIOS/trunk/extern/remap/src/tree.cpp	(revision 694)
@@ -4,5 +4,5 @@
 #include "elt.hpp"
 #include <iostream>
-#include <mpi.h>
+#include "mpi.hpp"
 #include <stdlib.h>     /* srand, rand */
 #include <time.h>       /* time */
Index: XIOS/trunk/extern/remap/test-main.cpp
===================================================================
--- XIOS/trunk/extern/remap/test-main.cpp	(revision 688)
+++ XIOS/trunk/extern/remap/test-main.cpp	(revision 694)
@@ -1,3 +1,3 @@
-#include <mpi.h>
+#include "mpi.hpp"
 #include <netcdf.h>
 #include "errhandle.hpp"