Index: XIOS/trunk/src/interface/c_attr/icfile_attr.cpp
===================================================================
--- XIOS/trunk/src/interface/c_attr/icfile_attr.cpp	(revision 698)
+++ XIOS/trunk/src/interface/c_attr/icfile_attr.cpp	(revision 699)
@@ -429,4 +429,30 @@
 
 
+  void cxios_set_file_time_counter(file_Ptr file_hdl, const char * time_counter, int time_counter_size)
+  {
+    std::string time_counter_str;
+    if (!cstr2string(time_counter, time_counter_size, time_counter_str)) return;
+    CTimer::get("XIOS").resume();
+    file_hdl->time_counter.fromString(time_counter_str);
+    CTimer::get("XIOS").suspend();
+  }
+
+  void cxios_get_file_time_counter(file_Ptr file_hdl, char * time_counter, int time_counter_size)
+  {
+    CTimer::get("XIOS").resume();
+    if (!string_copy(file_hdl->time_counter.getInheritedStringValue(), time_counter, time_counter_size))
+      ERROR("void cxios_get_file_time_counter(file_Ptr file_hdl, char * time_counter, int time_counter_size)", << "Input string is too short");
+    CTimer::get("XIOS").suspend();
+  }
+
+  bool cxios_is_defined_file_time_counter(file_Ptr file_hdl)
+  {
+     CTimer::get("XIOS").resume();
+     bool isDefined = file_hdl->time_counter.hasInheritedValue();
+     CTimer::get("XIOS").suspend();
+     return isDefined;
+  }
+
+
   void cxios_set_file_type(file_Ptr file_hdl, const char * type, int type_size)
   {
Index: XIOS/trunk/src/interface/c_attr/icfilegroup_attr.cpp
===================================================================
--- XIOS/trunk/src/interface/c_attr/icfilegroup_attr.cpp	(revision 698)
+++ XIOS/trunk/src/interface/c_attr/icfilegroup_attr.cpp	(revision 699)
@@ -455,4 +455,30 @@
 
 
+  void cxios_set_filegroup_time_counter(filegroup_Ptr filegroup_hdl, const char * time_counter, int time_counter_size)
+  {
+    std::string time_counter_str;
+    if (!cstr2string(time_counter, time_counter_size, time_counter_str)) return;
+    CTimer::get("XIOS").resume();
+    filegroup_hdl->time_counter.fromString(time_counter_str);
+    CTimer::get("XIOS").suspend();
+  }
+
+  void cxios_get_filegroup_time_counter(filegroup_Ptr filegroup_hdl, char * time_counter, int time_counter_size)
+  {
+    CTimer::get("XIOS").resume();
+    if (!string_copy(filegroup_hdl->time_counter.getInheritedStringValue(), time_counter, time_counter_size))
+      ERROR("void cxios_get_filegroup_time_counter(filegroup_Ptr filegroup_hdl, char * time_counter, int time_counter_size)", << "Input string is too short");
+    CTimer::get("XIOS").suspend();
+  }
+
+  bool cxios_is_defined_filegroup_time_counter(filegroup_Ptr filegroup_hdl)
+  {
+     CTimer::get("XIOS").resume();
+     bool isDefined = filegroup_hdl->time_counter.hasInheritedValue();
+     CTimer::get("XIOS").suspend();
+     return isDefined;
+  }
+
+
   void cxios_set_filegroup_type(filegroup_Ptr filegroup_hdl, const char * type, int type_size)
   {
Index: XIOS/trunk/src/interface/fortran_attr/file_interface_attr.F90
===================================================================
--- XIOS/trunk/src/interface/fortran_attr/file_interface_attr.F90	(revision 698)
+++ XIOS/trunk/src/interface/fortran_attr/file_interface_attr.F90	(revision 699)
@@ -315,4 +315,25 @@
 
 
+    SUBROUTINE cxios_set_file_time_counter(file_hdl, time_counter, time_counter_size) BIND(C)
+      USE ISO_C_BINDING
+      INTEGER (kind = C_INTPTR_T), VALUE :: file_hdl
+      CHARACTER(kind = C_CHAR)    , DIMENSION(*) :: time_counter
+      INTEGER  (kind = C_INT)     , VALUE        :: time_counter_size
+    END SUBROUTINE cxios_set_file_time_counter
+
+    SUBROUTINE cxios_get_file_time_counter(file_hdl, time_counter, time_counter_size) BIND(C)
+      USE ISO_C_BINDING
+      INTEGER (kind = C_INTPTR_T), VALUE :: file_hdl
+      CHARACTER(kind = C_CHAR)    , DIMENSION(*) :: time_counter
+      INTEGER  (kind = C_INT)     , VALUE        :: time_counter_size
+    END SUBROUTINE cxios_get_file_time_counter
+
+    FUNCTION cxios_is_defined_file_time_counter(file_hdl) BIND(C)
+      USE ISO_C_BINDING
+      LOGICAL(kind=C_BOOL) :: cxios_is_defined_file_time_counter
+      INTEGER (kind = C_INTPTR_T), VALUE :: file_hdl
+    END FUNCTION cxios_is_defined_file_time_counter
+
+
     SUBROUTINE cxios_set_file_type(file_hdl, type, type_size) BIND(C)
       USE ISO_C_BINDING
Index: XIOS/trunk/src/interface/fortran_attr/filegroup_interface_attr.F90
===================================================================
--- XIOS/trunk/src/interface/fortran_attr/filegroup_interface_attr.F90	(revision 698)
+++ XIOS/trunk/src/interface/fortran_attr/filegroup_interface_attr.F90	(revision 699)
@@ -336,4 +336,25 @@
 
 
+    SUBROUTINE cxios_set_filegroup_time_counter(filegroup_hdl, time_counter, time_counter_size) BIND(C)
+      USE ISO_C_BINDING
+      INTEGER (kind = C_INTPTR_T), VALUE :: filegroup_hdl
+      CHARACTER(kind = C_CHAR)    , DIMENSION(*) :: time_counter
+      INTEGER  (kind = C_INT)     , VALUE        :: time_counter_size
+    END SUBROUTINE cxios_set_filegroup_time_counter
+
+    SUBROUTINE cxios_get_filegroup_time_counter(filegroup_hdl, time_counter, time_counter_size) BIND(C)
+      USE ISO_C_BINDING
+      INTEGER (kind = C_INTPTR_T), VALUE :: filegroup_hdl
+      CHARACTER(kind = C_CHAR)    , DIMENSION(*) :: time_counter
+      INTEGER  (kind = C_INT)     , VALUE        :: time_counter_size
+    END SUBROUTINE cxios_get_filegroup_time_counter
+
+    FUNCTION cxios_is_defined_filegroup_time_counter(filegroup_hdl) BIND(C)
+      USE ISO_C_BINDING
+      LOGICAL(kind=C_BOOL) :: cxios_is_defined_filegroup_time_counter
+      INTEGER (kind = C_INTPTR_T), VALUE :: filegroup_hdl
+    END FUNCTION cxios_is_defined_filegroup_time_counter
+
+
     SUBROUTINE cxios_set_filegroup_type(filegroup_hdl, type, type_size) BIND(C)
       USE ISO_C_BINDING
Index: XIOS/trunk/src/interface/fortran_attr/ifile_attr.F90
===================================================================
--- XIOS/trunk/src/interface/fortran_attr/ifile_attr.F90	(revision 698)
+++ XIOS/trunk/src/interface/fortran_attr/ifile_attr.F90	(revision 699)
@@ -13,5 +13,6 @@
   SUBROUTINE xios(set_file_attr)  &
     ( file_id, append, compression_level, description, enabled, format, min_digits, mode, name, name_suffix  &
-    , output_freq, output_level, par_access, split_freq, split_freq_format, sync_freq, type )
+    , output_freq, output_level, par_access, split_freq, split_freq_format, sync_freq, time_counter  &
+    , type )
 
     IMPLICIT NONE
@@ -35,4 +36,5 @@
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: split_freq_format
       TYPE(txios(duration))  , OPTIONAL, INTENT(IN) :: sync_freq
+      CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: time_counter
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: type
 
@@ -41,5 +43,5 @@
       ( file_hdl, append, compression_level, description, enabled, format, min_digits, mode, name  &
       , name_suffix, output_freq, output_level, par_access, split_freq, split_freq_format, sync_freq  &
-      , type )
+      , time_counter, type )
 
   END SUBROUTINE xios(set_file_attr)
@@ -48,5 +50,5 @@
     ( file_hdl, append, compression_level, description, enabled, format, min_digits, mode, name  &
     , name_suffix, output_freq, output_level, par_access, split_freq, split_freq_format, sync_freq  &
-    , type )
+    , time_counter, type )
 
     IMPLICIT NONE
@@ -69,4 +71,5 @@
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: split_freq_format
       TYPE(txios(duration))  , OPTIONAL, INTENT(IN) :: sync_freq
+      CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: time_counter
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: type
 
@@ -74,5 +77,5 @@
       ( file_hdl, append, compression_level, description, enabled, format, min_digits, mode, name  &
       , name_suffix, output_freq, output_level, par_access, split_freq, split_freq_format, sync_freq  &
-      , type )
+      , time_counter, type )
 
   END SUBROUTINE xios(set_file_attr_hdl)
@@ -81,5 +84,5 @@
     ( file_hdl, append_, compression_level_, description_, enabled_, format_, min_digits_, mode_  &
     , name_, name_suffix_, output_freq_, output_level_, par_access_, split_freq_, split_freq_format_  &
-    , sync_freq_, type_ )
+    , sync_freq_, time_counter_, type_ )
 
     IMPLICIT NONE
@@ -102,4 +105,5 @@
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: split_freq_format_
       TYPE(txios(duration))  , OPTIONAL, INTENT(IN) :: sync_freq_
+      CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: time_counter_
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: type_
 
@@ -166,4 +170,8 @@
       ENDIF
 
+      IF (PRESENT(time_counter_)) THEN
+        CALL cxios_set_file_time_counter(file_hdl%daddr, time_counter_, len(time_counter_))
+      ENDIF
+
       IF (PRESENT(type_)) THEN
         CALL cxios_set_file_type(file_hdl%daddr, type_, len(type_))
@@ -174,5 +182,6 @@
   SUBROUTINE xios(get_file_attr)  &
     ( file_id, append, compression_level, description, enabled, format, min_digits, mode, name, name_suffix  &
-    , output_freq, output_level, par_access, split_freq, split_freq_format, sync_freq, type )
+    , output_freq, output_level, par_access, split_freq, split_freq_format, sync_freq, time_counter  &
+    , type )
 
     IMPLICIT NONE
@@ -196,4 +205,5 @@
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: split_freq_format
       TYPE(txios(duration))  , OPTIONAL, INTENT(OUT) :: sync_freq
+      CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: time_counter
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: type
 
@@ -202,5 +212,5 @@
       ( file_hdl, append, compression_level, description, enabled, format, min_digits, mode, name  &
       , name_suffix, output_freq, output_level, par_access, split_freq, split_freq_format, sync_freq  &
-      , type )
+      , time_counter, type )
 
   END SUBROUTINE xios(get_file_attr)
@@ -209,5 +219,5 @@
     ( file_hdl, append, compression_level, description, enabled, format, min_digits, mode, name  &
     , name_suffix, output_freq, output_level, par_access, split_freq, split_freq_format, sync_freq  &
-    , type )
+    , time_counter, type )
 
     IMPLICIT NONE
@@ -230,4 +240,5 @@
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: split_freq_format
       TYPE(txios(duration))  , OPTIONAL, INTENT(OUT) :: sync_freq
+      CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: time_counter
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: type
 
@@ -235,5 +246,5 @@
       ( file_hdl, append, compression_level, description, enabled, format, min_digits, mode, name  &
       , name_suffix, output_freq, output_level, par_access, split_freq, split_freq_format, sync_freq  &
-      , type )
+      , time_counter, type )
 
   END SUBROUTINE xios(get_file_attr_hdl)
@@ -242,5 +253,5 @@
     ( file_hdl, append_, compression_level_, description_, enabled_, format_, min_digits_, mode_  &
     , name_, name_suffix_, output_freq_, output_level_, par_access_, split_freq_, split_freq_format_  &
-    , sync_freq_, type_ )
+    , sync_freq_, time_counter_, type_ )
 
     IMPLICIT NONE
@@ -263,4 +274,5 @@
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: split_freq_format_
       TYPE(txios(duration))  , OPTIONAL, INTENT(OUT) :: sync_freq_
+      CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: time_counter_
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: type_
 
@@ -327,4 +339,8 @@
       ENDIF
 
+      IF (PRESENT(time_counter_)) THEN
+        CALL cxios_get_file_time_counter(file_hdl%daddr, time_counter_, len(time_counter_))
+      ENDIF
+
       IF (PRESENT(type_)) THEN
         CALL cxios_get_file_type(file_hdl%daddr, type_, len(type_))
@@ -335,5 +351,6 @@
   SUBROUTINE xios(is_defined_file_attr)  &
     ( file_id, append, compression_level, description, enabled, format, min_digits, mode, name, name_suffix  &
-    , output_freq, output_level, par_access, split_freq, split_freq_format, sync_freq, type )
+    , output_freq, output_level, par_access, split_freq, split_freq_format, sync_freq, time_counter  &
+    , type )
 
     IMPLICIT NONE
@@ -370,4 +387,6 @@
       LOGICAL, OPTIONAL, INTENT(OUT) :: sync_freq
       LOGICAL(KIND=C_BOOL) :: sync_freq_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: time_counter
+      LOGICAL(KIND=C_BOOL) :: time_counter_tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: type
       LOGICAL(KIND=C_BOOL) :: type_tmp
@@ -377,5 +396,5 @@
       ( file_hdl, append, compression_level, description, enabled, format, min_digits, mode, name  &
       , name_suffix, output_freq, output_level, par_access, split_freq, split_freq_format, sync_freq  &
-      , type )
+      , time_counter, type )
 
   END SUBROUTINE xios(is_defined_file_attr)
@@ -384,5 +403,5 @@
     ( file_hdl, append, compression_level, description, enabled, format, min_digits, mode, name  &
     , name_suffix, output_freq, output_level, par_access, split_freq, split_freq_format, sync_freq  &
-    , type )
+    , time_counter, type )
 
     IMPLICIT NONE
@@ -418,4 +437,6 @@
       LOGICAL, OPTIONAL, INTENT(OUT) :: sync_freq
       LOGICAL(KIND=C_BOOL) :: sync_freq_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: time_counter
+      LOGICAL(KIND=C_BOOL) :: time_counter_tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: type
       LOGICAL(KIND=C_BOOL) :: type_tmp
@@ -424,5 +445,5 @@
       ( file_hdl, append, compression_level, description, enabled, format, min_digits, mode, name  &
       , name_suffix, output_freq, output_level, par_access, split_freq, split_freq_format, sync_freq  &
-      , type )
+      , time_counter, type )
 
   END SUBROUTINE xios(is_defined_file_attr_hdl)
@@ -431,5 +452,5 @@
     ( file_hdl, append_, compression_level_, description_, enabled_, format_, min_digits_, mode_  &
     , name_, name_suffix_, output_freq_, output_level_, par_access_, split_freq_, split_freq_format_  &
-    , sync_freq_, type_ )
+    , sync_freq_, time_counter_, type_ )
 
     IMPLICIT NONE
@@ -465,4 +486,6 @@
       LOGICAL, OPTIONAL, INTENT(OUT) :: sync_freq_
       LOGICAL(KIND=C_BOOL) :: sync_freq__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: time_counter_
+      LOGICAL(KIND=C_BOOL) :: time_counter__tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: type_
       LOGICAL(KIND=C_BOOL) :: type__tmp
@@ -543,4 +566,9 @@
       ENDIF
 
+      IF (PRESENT(time_counter_)) THEN
+        time_counter__tmp = cxios_is_defined_file_time_counter(file_hdl%daddr)
+        time_counter_ = time_counter__tmp
+      ENDIF
+
       IF (PRESENT(type_)) THEN
         type__tmp = cxios_is_defined_file_type(file_hdl%daddr)
Index: XIOS/trunk/src/interface/fortran_attr/ifilegroup_attr.F90
===================================================================
--- XIOS/trunk/src/interface/fortran_attr/ifilegroup_attr.F90	(revision 698)
+++ XIOS/trunk/src/interface/fortran_attr/ifilegroup_attr.F90	(revision 699)
@@ -14,5 +14,5 @@
     ( filegroup_id, append, compression_level, description, enabled, format, group_ref, min_digits  &
     , mode, name, name_suffix, output_freq, output_level, par_access, split_freq, split_freq_format  &
-    , sync_freq, type )
+    , sync_freq, time_counter, type )
 
     IMPLICIT NONE
@@ -37,4 +37,5 @@
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: split_freq_format
       TYPE(txios(duration))  , OPTIONAL, INTENT(IN) :: sync_freq
+      CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: time_counter
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: type
 
@@ -43,5 +44,5 @@
       ( filegroup_hdl, append, compression_level, description, enabled, format, group_ref, min_digits  &
       , mode, name, name_suffix, output_freq, output_level, par_access, split_freq, split_freq_format  &
-      , sync_freq, type )
+      , sync_freq, time_counter, type )
 
   END SUBROUTINE xios(set_filegroup_attr)
@@ -50,5 +51,5 @@
     ( filegroup_hdl, append, compression_level, description, enabled, format, group_ref, min_digits  &
     , mode, name, name_suffix, output_freq, output_level, par_access, split_freq, split_freq_format  &
-    , sync_freq, type )
+    , sync_freq, time_counter, type )
 
     IMPLICIT NONE
@@ -72,4 +73,5 @@
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: split_freq_format
       TYPE(txios(duration))  , OPTIONAL, INTENT(IN) :: sync_freq
+      CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: time_counter
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: type
 
@@ -77,5 +79,5 @@
       ( filegroup_hdl, append, compression_level, description, enabled, format, group_ref, min_digits  &
       , mode, name, name_suffix, output_freq, output_level, par_access, split_freq, split_freq_format  &
-      , sync_freq, type )
+      , sync_freq, time_counter, type )
 
   END SUBROUTINE xios(set_filegroup_attr_hdl)
@@ -84,5 +86,5 @@
     ( filegroup_hdl, append_, compression_level_, description_, enabled_, format_, group_ref_, min_digits_  &
     , mode_, name_, name_suffix_, output_freq_, output_level_, par_access_, split_freq_, split_freq_format_  &
-    , sync_freq_, type_ )
+    , sync_freq_, time_counter_, type_ )
 
     IMPLICIT NONE
@@ -106,4 +108,5 @@
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: split_freq_format_
       TYPE(txios(duration))  , OPTIONAL, INTENT(IN) :: sync_freq_
+      CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: time_counter_
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: type_
 
@@ -174,4 +177,8 @@
       ENDIF
 
+      IF (PRESENT(time_counter_)) THEN
+        CALL cxios_set_filegroup_time_counter(filegroup_hdl%daddr, time_counter_, len(time_counter_))
+      ENDIF
+
       IF (PRESENT(type_)) THEN
         CALL cxios_set_filegroup_type(filegroup_hdl%daddr, type_, len(type_))
@@ -183,5 +190,5 @@
     ( filegroup_id, append, compression_level, description, enabled, format, group_ref, min_digits  &
     , mode, name, name_suffix, output_freq, output_level, par_access, split_freq, split_freq_format  &
-    , sync_freq, type )
+    , sync_freq, time_counter, type )
 
     IMPLICIT NONE
@@ -206,4 +213,5 @@
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: split_freq_format
       TYPE(txios(duration))  , OPTIONAL, INTENT(OUT) :: sync_freq
+      CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: time_counter
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: type
 
@@ -212,5 +220,5 @@
       ( filegroup_hdl, append, compression_level, description, enabled, format, group_ref, min_digits  &
       , mode, name, name_suffix, output_freq, output_level, par_access, split_freq, split_freq_format  &
-      , sync_freq, type )
+      , sync_freq, time_counter, type )
 
   END SUBROUTINE xios(get_filegroup_attr)
@@ -219,5 +227,5 @@
     ( filegroup_hdl, append, compression_level, description, enabled, format, group_ref, min_digits  &
     , mode, name, name_suffix, output_freq, output_level, par_access, split_freq, split_freq_format  &
-    , sync_freq, type )
+    , sync_freq, time_counter, type )
 
     IMPLICIT NONE
@@ -241,4 +249,5 @@
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: split_freq_format
       TYPE(txios(duration))  , OPTIONAL, INTENT(OUT) :: sync_freq
+      CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: time_counter
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: type
 
@@ -246,5 +255,5 @@
       ( filegroup_hdl, append, compression_level, description, enabled, format, group_ref, min_digits  &
       , mode, name, name_suffix, output_freq, output_level, par_access, split_freq, split_freq_format  &
-      , sync_freq, type )
+      , sync_freq, time_counter, type )
 
   END SUBROUTINE xios(get_filegroup_attr_hdl)
@@ -253,5 +262,5 @@
     ( filegroup_hdl, append_, compression_level_, description_, enabled_, format_, group_ref_, min_digits_  &
     , mode_, name_, name_suffix_, output_freq_, output_level_, par_access_, split_freq_, split_freq_format_  &
-    , sync_freq_, type_ )
+    , sync_freq_, time_counter_, type_ )
 
     IMPLICIT NONE
@@ -275,4 +284,5 @@
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: split_freq_format_
       TYPE(txios(duration))  , OPTIONAL, INTENT(OUT) :: sync_freq_
+      CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: time_counter_
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: type_
 
@@ -343,4 +353,8 @@
       ENDIF
 
+      IF (PRESENT(time_counter_)) THEN
+        CALL cxios_get_filegroup_time_counter(filegroup_hdl%daddr, time_counter_, len(time_counter_))
+      ENDIF
+
       IF (PRESENT(type_)) THEN
         CALL cxios_get_filegroup_type(filegroup_hdl%daddr, type_, len(type_))
@@ -352,5 +366,5 @@
     ( filegroup_id, append, compression_level, description, enabled, format, group_ref, min_digits  &
     , mode, name, name_suffix, output_freq, output_level, par_access, split_freq, split_freq_format  &
-    , sync_freq, type )
+    , sync_freq, time_counter, type )
 
     IMPLICIT NONE
@@ -389,4 +403,6 @@
       LOGICAL, OPTIONAL, INTENT(OUT) :: sync_freq
       LOGICAL(KIND=C_BOOL) :: sync_freq_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: time_counter
+      LOGICAL(KIND=C_BOOL) :: time_counter_tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: type
       LOGICAL(KIND=C_BOOL) :: type_tmp
@@ -396,5 +412,5 @@
       ( filegroup_hdl, append, compression_level, description, enabled, format, group_ref, min_digits  &
       , mode, name, name_suffix, output_freq, output_level, par_access, split_freq, split_freq_format  &
-      , sync_freq, type )
+      , sync_freq, time_counter, type )
 
   END SUBROUTINE xios(is_defined_filegroup_attr)
@@ -403,5 +419,5 @@
     ( filegroup_hdl, append, compression_level, description, enabled, format, group_ref, min_digits  &
     , mode, name, name_suffix, output_freq, output_level, par_access, split_freq, split_freq_format  &
-    , sync_freq, type )
+    , sync_freq, time_counter, type )
 
     IMPLICIT NONE
@@ -439,4 +455,6 @@
       LOGICAL, OPTIONAL, INTENT(OUT) :: sync_freq
       LOGICAL(KIND=C_BOOL) :: sync_freq_tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: time_counter
+      LOGICAL(KIND=C_BOOL) :: time_counter_tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: type
       LOGICAL(KIND=C_BOOL) :: type_tmp
@@ -445,5 +463,5 @@
       ( filegroup_hdl, append, compression_level, description, enabled, format, group_ref, min_digits  &
       , mode, name, name_suffix, output_freq, output_level, par_access, split_freq, split_freq_format  &
-      , sync_freq, type )
+      , sync_freq, time_counter, type )
 
   END SUBROUTINE xios(is_defined_filegroup_attr_hdl)
@@ -452,5 +470,5 @@
     ( filegroup_hdl, append_, compression_level_, description_, enabled_, format_, group_ref_, min_digits_  &
     , mode_, name_, name_suffix_, output_freq_, output_level_, par_access_, split_freq_, split_freq_format_  &
-    , sync_freq_, type_ )
+    , sync_freq_, time_counter_, type_ )
 
     IMPLICIT NONE
@@ -488,4 +506,6 @@
       LOGICAL, OPTIONAL, INTENT(OUT) :: sync_freq_
       LOGICAL(KIND=C_BOOL) :: sync_freq__tmp
+      LOGICAL, OPTIONAL, INTENT(OUT) :: time_counter_
+      LOGICAL(KIND=C_BOOL) :: time_counter__tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: type_
       LOGICAL(KIND=C_BOOL) :: type__tmp
@@ -571,4 +591,9 @@
       ENDIF
 
+      IF (PRESENT(time_counter_)) THEN
+        time_counter__tmp = cxios_is_defined_filegroup_time_counter(filegroup_hdl%daddr)
+        time_counter_ = time_counter__tmp
+      ENDIF
+
       IF (PRESENT(type_)) THEN
         type__tmp = cxios_is_defined_filegroup_type(filegroup_hdl%daddr)